#lang racket

;;;; 4. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 8.3.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - symbolické výrazy,
;;;; - aplikácie zoznamov,
;;;; - obecné stromy,
;;;; - výroková logika.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 1
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 2
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0
;;;; Odovzdať do 13.3.2016 (nedeľa).

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define nil null)

;;; Kapitola. Zoznamy.

;;; Sekcia. Konečné množiny ako usporiadané zoznamy.

;; Úloha. Zostrojte program, ktorý vypočíta zjednotenie dvoch množín.

(define (union set1 set2) ...)

;; (union '(1 2 4 6 8) '(2 3 5 6 7))

;; Úloha. Zostrojte program, ktorý vypočíta prienik dvoch množín.

(define (intersection set1 set2) ...)

;; (intersection '(1 2 4 6 8) '(2 3 5 6 7))

;; Úloha. Zostrojte program, ktorý vypočíta rozdiel dvoch množín.

(define (difference set1 set2) ...)

;; (difference '(1 2 4 6 8) '(2 3 5 6 7))

;; Úloha. Zostrojte program, ktorý vypočíta symetrický rozdiel dvoch množín.

(define (symmetric-difference set1 set2) ...)

;; (symmetric-difference '(1 2 4 6 8) '(2 3 5 6 7))

;; Úloha. Zostrojte program, ktorý otestuje, či platí vzťah rovnosti medzi
;; množinami.

(define (eqset? set1 set2) ...)

;; (eqset? '(1 2 3 4) '(1 2 3 4))
;; (eqset? '(1 2 3 4) '(1 2 4 5))

;; Úloha. Zostrojte program, ktorý otestuje, či platí vzťah inklúzie medzi
;; množinami.

(define (subset? set1 set2) ...)

;; (subset? '(2 4 6 8) '(1 2 3 4 5 6 7 8))
;; (subset? '(2 4 6 8) '(1 2 3 4 7 8 9))

;; (1 bod)
;; Úloha. Implementujte program, ktorý vráti všetky podmnožiny danej množiny.
;; Výsledok reprezentujte ako zoznam podmnožín.

(define (subsets set) ...)

;; (subsets '())
;; (subsets '(1))
;; (subsets '(1 2))
;; (subsets '(1 2 3))
;; (subsets '(1 2 3 4))

;;; Sekcia. Kombinatorika na zoznamoch.

;; Definícia. Rozkladom zoznamu rozumieme taký zoznam neprázdnych zoznamov,
;; ktorých zreťazením dostaneme pôvodný zoznam.
;;   Príklad: '((1 2 3) (4) (5 6)) je rozkladom zoznamu '(1 2 3 4 5 6).

;; (prémia 2 body)
;; Úloha. Implementujte program, ktorý vráti všetky rozklady daného zoznamu.
;; Výsledok reprezentujte ako zoznam rozkladov.

(define (partitions xs) ...)

;; (partitions '())
;; (partitions '(1))
;; (partitions '(1 2))
;; (partitions '(1 2 3))
;; (partitions '(1 2 3 4))
