#lang racket

;;;; 4. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 8.3.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - symbolické výrazy,
;;;; - aplikácie zoznamov,
;;;; - obecné stromy,
;;;; - výroková logika.
;;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 2
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 2
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0
;;;; Odovzdať do 13.3.2016 (nedeľa).

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Zopakovanie.

(define identity (λ (x) x))
(define zero (λ (x) 0))
(define one (λ (x) 1))
(define succ (λ (x) (+ x 1)))
(define singleton (λ (x) (list x)))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define nil null)

;;; Kapitola. Stromy.

;;; Sekcia. Obecné stromy.

;; Príklad. Nasledujúci komponent obsahuje definiciu obecných stromov.

(define (tree? t)
  (define (forest? ts)
    (or (null? ts)
        (and (pair? ts)
             (tree? (car ts))
             (forest? (cdr ts)))))
  (and (pair? t)
       (number? (car t))
       (forest? (cdr t))))

;; (tree? '(1))
;; (tree? '(1 (2) (3)))
;; (tree? '(1 (2 (3)) (4 (5) (6) (7)) (8)))

;; Úloha. Zostrojte program, ktorý spočíta počet uzlov v strome.

(define (count-nodes t) ...)

;; (count-nodes '(1))
;; (count-nodes '(1 (2) (3)))
;; (count-nodes '(1 (2 (3)) (4 (5) (6) (7)) (8)))

;; Úloha. Zostrojte program, ktorý počíta výšku (hĺbku) stromu.

(define (height t) ...)

;; (height '(1))
;; (height '(1 (2) (3)))
;; (height '(1 (2 (3)) (4 (5) (6) (7)) (8)))

;; Úloha. Zostrojte program, ktorý vráti zoznam všetkých uzlov v strome, ktorý
;; odpovedá priamemu prechodu stromom.

(define (preorder t) ...)

;; (preorder '(1))
;; (preorder '(1 (2) (3)))
;; (preorder '(1 (2 (3)) (4 (5) (6) (7)) (8)))

;; Úloha. Zostrojte program, ktorý vytvorí zrkadlový obraz vstupného stromu.

(define (reflect t) ...)

;; (reflect '(1))
;; (reflect '(1 (2) (3)))
;; (reflect '(1 (2 (3)) (4 (5) (6) (7)) (8)))

;; Úloha. Zostrojte program pre funkcionál
;;   accumulate(tree,node-value,forest-value,combiner,null-value),
;; ktorý univerzálne akumuluje hodnoty daného rozsahu pre strom tree:
;; - node-value je funkcia aplikujúca sa na jednotlivé uzly stromu,
;; - forest-value je funkcia aplikujúca sa na výsledok operácie combiner,
;; - combiner je akumulujúca funkcia aplikujúca sa na les,
;; - null-value je neutrálny prvok vzhľadom na combiner.

(define (accumulate tree node-value forest-value combiner null-value) ...)

;; (2 body)
;; Úloha. Definujte tieto funkcie z predošlých príkladov pomocou accumulate.

(define (count-nodes2 t) ...)
(define (height2 t) ...)
(define (preorder2 t) ...)
(define (reflect2 t) ...)

;; (count-nodes2 '(1 (2 (3)) (4 (5) (6) (7)) (8)))
;; (height2 '(1 (2 (3)) (4 (5) (6) (7)) (8)))
;; (preorder2 '(1 (2 (3)) (4 (5) (6) (7)) (8)))
;; (reflect2 '(1 (2 (3)) (4 (5) (6) (7)) (8)))

;; (prémia 2 body)
;; Úloha. Zostrojte program, ktorý nahradí listy daného stromu číslami 1,2,3,...
;; v tomto poradí.

(define (numbering t1) ...)

;; (numbering '(2))
;; (numbering '(2 (3) (5)))
;; (numbering '(2 (3 (5)) (7 (11) (13) (17)) (19)))
