#lang racket

;;;; 4. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 8.3.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - symbolické výrazy,
;;;; - aplikácie zoznamov,
;;;; - obecné stromy,
;;;; - výroková logika.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 3
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 2
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0
;;;; Odovzdať do 13.3.2016 (nedeľa).

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Zopakovanie.

(define (compose f g) (λ (x) (g (f x))))

(define (each? p? xs)
  (if (null? xs) #t (and (p? (car xs)) (each? p? (cdr xs)))))

(define (member-set? x set)
  (and (pair? set)
       (or (= x (car set))
           (and (> x (car set))
                (member-set? x (cdr set))))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define nil null)

;;; Kapitola. Výroková logika.

;;; Sekcia. Jazyk výrokovej logiky.

;; Konštruktory.

(define (VAR i) (list 'VAR i))
(define TRUE (list 'TRUE))
(define FALSE (list 'FALSE))
(define (NOT a) (list 'NOT a))
(define (AND a b) (list 'AND a b))
(define (OR a b) (list 'OR  a b))
(define (IMP a b) (list 'IMP a b))
(define (IFF a b) (list 'IFF a b))

;; Predikáty.

(define (VAR? a) (eq? (list-ref a 0) 'VAR))
(define (TRUE? a) (eq? (list-ref a 0) 'TRUE))
(define (FALSE? a) (eq? (list-ref a 0) 'FALSE))
(define (NOT? a) (eq? (list-ref a 0) 'NOT))
(define (AND? a) (eq? (list-ref a 0) 'AND))
(define (OR? a) (eq? (list-ref a 0) 'OR))
(define (IMP? a) (eq? (list-ref a 0) 'IMP))
(define (IFF? a) (eq? (list-ref a 0) 'IFF))

(define (atom? a) (or (VAR? a) (TRUE? a) (FALSE? a)))
(define (bin? a) (or (AND? a) (OR? a) (IMP? a) (IFF? a)))

;; Selektory.

(define (var-index a) (list-ref a 1))
(define (conn-arg1 a) (list-ref a 1))
(define (conn-arg2 a) (list-ref a 2))

;; (var-index (VAR 1))
;; (conn-arg1 (NOT (VAR 1)))
;; (conn-arg1 (AND (VAR 1) (VAR 2)))
;; (conn-arg2 (AND (VAR 1) (VAR 2)))

;; Úloha. Definujte predikát, ktorý overí, či vstup je výrokovo-logická formula.

(define (formula? a) ...)

;; (formula? (VAR 1))
;; (formula? TRUE)
;; (formula? FALSE)
;; (formula? (NOT (AND (VAR 1) (OR (VAR 2) (IMP (VAR 3) (IFF (VAR 4) (VAR 5)))))))

;; Úloha. Zostrojte program, ktorý pre danú formulu vráti množinu indexov
;; výrokovo-logických premenných, ktoré sa v nej vyskytujú.

(define (variables a) ...)

;; (variables (VAR 1))
;; (variables TRUE)
;; (variables FALSE)
;; (variables (NOT (AND (VAR 1) (OR (VAR 2) (IMP (VAR 3) (IFF (VAR 4) (VAR 5)))))))

;;; Sekcia. Sémantika výrokovej logiky.

;; Úloha. Definujte binárny predikát, ktorý urči pravdivostnú hodnotu formuly
;; pri danom výrokovo-logickom ohodnoteni.

(define (true? v a) ...)

;; Definícia. Formula je tautológia, ak je pravdivá pri každom
;; výrokovo-logickom ohodnotení.

;; Príklad. Nasledujúce formuly sú tautológie.

(define A1 (IFF (OR (VAR 1) (AND (VAR 2) (VAR 3))) (AND (OR (VAR 1) (VAR 2)) (OR (VAR 1) (VAR 3)))))
(define A2 (IMP (AND (IMP (VAR 1) (VAR 2)) (IMP (VAR 2) (VAR 3))) (IMP (VAR 1) (VAR 3))))
(define A3 (IFF (IMP (VAR 1) (VAR 2)) (IMP (NOT (VAR 2)) (NOT (VAR 1)))))
(define A4 (IFF (IFF (VAR 1) (VAR 2)) (IMP (OR (VAR 1) (VAR 2)) (AND (VAR 1) (VAR 2)))))
(define A5 (IMP (VAR 1) (IMP (VAR 2) (VAR 1))))
(define A6 (IMP (AND (AND (IMP (VAR 1) (VAR 3)) (IMP (VAR 2) (VAR 3))) (OR (VAR 1) (VAR 2))) (VAR 3)))
(define A7 (IFF (NOT (IMP (VAR 1) (VAR 2))) (AND (VAR 1) (NOT (VAR 2)))))

;; (formula? A1)
;; (each? formula? (list A1 A2 A3 A4 A5 A6 A7))

;; Príklad. Nasledujúce formuly nie sú tautológie.

(define B1 (IMP (OR (VAR 1) (VAR 2)) (AND (VAR 1) (VAR 2))))
(define B2 (IFF (IMP (VAR 1) (VAR 2)) (IMP (VAR 2) (VAR 1))))
(define B3 (IMP (IMP (VAR 1) (VAR 2)) (IMP (NOT (VAR 1)) (NOT (VAR 2)))))
(define B4 (IMP (IMP (AND (VAR 1) (VAR 2)) (VAR 3)) (AND (IMP (VAR 1) (VAR 3)) (IMP (VAR 2) (VAR 3)))))

;; (formula? B1)
;; (each? formula? (list B1 B2 B3 B4))

;; (3 body)
;; Úloha. Zostrojte program, ktorý pomocou tabuľkovej metódy urči, či daná
;; formula je tautológia.

(define (tautology? a) ...)

;; (tautology? A1)
;; (each? tautology? (list A1 A2 A3 A4 A5 A6 A7))
;; (not (tautology? B1))
;; (each? (compose tautology? not) (list B1 B2 B3 B4))

;;; Sekcia. Normálne formy výrokovo-logických formúl.

;; Definícia. Formula je v negačnej normálnej forme, ak negácia sa v nej
;; vyskytuje iba pri výrokovo-logických premenných.

(define (nnf? a)
  (or (VAR? a)
      (TRUE? a)
      (FALSE? a)
      (and (NOT? a) (VAR? (conn-arg1 a)))
      (and (bin? a) (nnf? (conn-arg1 a)) (nnf? (conn-arg2 a)))))

;; (prémia 2 body)
;; Úloha. Zostrojte program, ktorý danú formulu transformuje do ekvivalentnej
;; negačnej normálnej formy.

(define (form->nnf a) ...)

;; (define C1 (NOT B1))
;; C1
;; (define C1->nnf (form->nnf C1))
;; C1->nnf
;; (formula? C1->nnf)
;; (nnf? C1->nnf)
;; (tautology? (IFF C1 C1->nnf))
